// MedDLeEdit.cpp 
#include "stdafx.h"
#include "MedDLe.h"
#include "2DView.h"
#include "MedDLeEdit.h"		// Our added edit routines

//void FindMinMax(CMedDLeDoc *pDoc);


int OnPoint(CMedDLeDoc* pDoc, CRect rc, CPoint point, int view)
{
	return 1;
}

void RotateSelected(CMedDLeDoc* pDoc, float a, float head[3], float tail[3] )
{
/*	int i,j;

	a=a*3.141596/180.;
	float s, c;
	s=sin(a); c=cos(a);

	float dx,dy,dz,dd,dr;
	dx=head[0]-tail[0];
	dy=head[1]-tail[1];
	dz=head[2]-tail[2];
	dr=dx*dx+dy*dy+dz*dz;
	dr=sqrt(dr);
	
	dd=sqrt(dx*dx+dy*dy);
	
	double dtheta,dphi;
	if(dd!=0) 
		dtheta=atan2(dd,dz);
	else dtheta=0.;
	if(dy!=0) 
		dphi=atan2(dy,dx);
	else dphi=0.;
	double dcp, dsp, dct,dst;
	dct=cos(-dtheta); dst=sin(-dtheta);
	dcp=cos(dphi); dsp=sin(dphi);
	for( i=0; i<pDoc->num.vertices; i++)
	{

		if ((!(pDoc->Verts[i].flags & O_VHIDDEN))&&(pDoc->Verts[i].flags & O_VSELECTED)) 
		{
			// rotate the point
			// put point in axis frame
			double x[3],xp[3],xpp[3];
			for (j=0; j<3; j++)
				x[j]=pDoc->cur.frameptr->fv[i].v[j]-tail[j];
	
			xp[0]=dcp*x[0]+dsp*x[1];
			xp[1]=-dsp*x[0]+dcp*x[1];
			xp[2]=x[2];

			x[0]=dct*xp[0]+dst*xp[2];
			x[1]=xp[1];
			x[2]=-dst*xp[0]+dct*xp[2];



			// rotate around axis
			float tx[2];
			tx[0]=c*x[0]+s*x[1];
			tx[1]=-s*x[0]+c*x[1];
			x[0]=tx[0]; 
			x[1]=tx[1]; 

			// put back in real space
			

			xp[0]=dct*x[0]-dst*x[2];
			xp[1]=x[1];
			xp[2]=dst*x[0]+dct*x[2];

			x[0]=dcp*xp[0]-dsp*xp[1];
			x[1]=dsp*xp[0]+dcp*xp[1];
			x[2]=xp[2];
			for (j=0; j<3; j++)
				pDoc->cur.frameptr->fv[i].v[j]=x[j]+tail[j];
		}
	}
	FindMinMax(pDoc);
	*/
}

void ScaleSelected(CMedDLeDoc* pDoc, float s[3])
{
	float x[3];

	// find center of mass
	float min[3]={1e23,1e23,1e23};
	float max[3]={-1e23,-1e23,-1e23};
	float c[3]={0,0,0};
	int numsel=0,i,j;
	for( i=0; i<pDoc->m_MedDLeObject.m_BaseFrame->v.GetSize(); i++)
	{
		if ((pDoc->m_MedDLeObject.m_BaseFrame->v[i].flags & V_VISIBLE)
			&&(pDoc->m_MedDLeObject.m_BaseFrame->v[i].flags & V_SELECTED)) 
		{
			for(j=0; j<3; j++)
			{
				if(pDoc->m_MedDLeObject.m_curFrame->v[i].x[j]<min[j]) min[j]=pDoc->m_MedDLeObject.m_curFrame->v[i].x[j];
				if(pDoc->m_MedDLeObject.m_curFrame->v[i].x[j]>max[j]) max[j]=pDoc->m_MedDLeObject.m_curFrame->v[i].x[j];
			}
			numsel++;
		}
	} 
	if(numsel <=0 ) return;
	for(j=0; j<3; j++) 
		c[j]=(max[j]+min[j])/2.;

	for(i=0; i<pDoc->m_MedDLeObject.m_BaseFrame->v.GetSize(); i++)
	{
		if ((pDoc->m_MedDLeObject.m_BaseFrame->v[i].flags & V_VISIBLE)&&(pDoc->m_MedDLeObject.m_BaseFrame->v[i].flags & V_SELECTED))
		{
			for(j=0; j<3; j++)
			{
				float x;
				x=pDoc->m_MedDLeObject.m_curFrame->v[i].x[j];
				x= (x-c[j])*s[j];
				pDoc->m_MedDLeObject.m_curFrame->v[i].x[j]=c[j]+x;
			}
		}
	}
//	FindMinMax(pDoc);
	
}

void FindMinMax(CMedDLeDoc *pDoc)
{
	float min[3]={1e23,1e23,1e23};
	float max[3]={-1e23,-1e23,-1e23};
	float min2[3]={1e23,1e23,1e23};
	float max2[3]={-1e23,-1e23,-1e23};

	CMedDLeFrame *f;
	f=pDoc->m_MedDLeObject.m_curFrame;
//	if (pDoc->Frames.GetSize()!=0)
//	{
	if (f != NULL)
	{
			min[0]=f->v[0].x[0];
			min[1]=f->v[0].x[1];
			min[2]=f->v[0].x[2];
			max[0]=min[0];
			max[1]=min[1];
			max[2]=min[2];
			// get bounds of cur frame
			for (int i=0; i<pDoc->m_MedDLeObject.m_BaseFrame->v.GetSize(); i++)
			{
				if(f->v[i].x[0]<min[0]) min[0]=f->v[i].x[0];
				else if(f->v[i].x[0]>max[0]) max[0]=f->v[i].x[0];
				if(f->v[i].x[1]<min[1]) min[1]=f->v[i].x[1];
				else if(f->v[i].x[1]>max[1]) max[1]=f->v[i].x[1];
				if(f->v[i].x[2]<min[2]) min[2]=f->v[i].x[2];
				else if(f->v[i].x[2]>max[2]) max[2]=f->v[i].x[2];
			}
//			for(int j=0; j<3; j++)
//			{
//				pDoc->cur.frameptr->fbboxmin.v[j]=min[j];
//				pDoc->cur.frameptr->fbboxmax.v[j]=max[j];
//			}

	}
		// find total bounds
/*		min2[0]=pDoc->Frames[0]->fbboxmin.v[0];
		min2[1]=pDoc->Frames[0]->fbboxmin.v[1];
		min2[2]=pDoc->Frames[0]->fbboxmin.v[2];
		max2[0]=pDoc->Frames[0]->fbboxmax.v[0];
		max2[1]=pDoc->Frames[0]->fbboxmax.v[1];
		max2[2]=pDoc->Frames[0]->fbboxmax.v[2];
		if(pDoc->cur.frame>=0)
		{

			for(int i=0; i<pDoc->Frames.GetSize(); i++)
			{
				for(int j=0; j<3; j++)
				{
					if (pDoc->Frames[i]->fbboxmin.v[j]<min2[j]) min2[j]=pDoc->Frames[i]->fbboxmin.v[j];
					if (pDoc->Frames[i]->fbboxmax.v[j]>max2[j]) max2[j]=pDoc->Frames[i]->fbboxmax.v[j];
				}
			}
			pDoc->boxmax[0]=max2[0];
			pDoc->boxmin[0]=min2[0];
			pDoc->boxmax[1]=max2[1];
			pDoc->boxmin[1]=min2[1];
			pDoc->boxmax[2]=max2[2];
			pDoc->boxmin[2]=min2[2];
		}
	}
	*/
}

void FindMinMaxAll(CMedDLeDoc *pDoc)
{
/*	float min[3]={1e23,1e23,1e23};
	float max[3]={-1e23,-1e23,-1e23};
	float min2[3]={1e23,1e23,1e23};
	float max2[3]={-1e23,-1e23,-1e23};

	if (pDoc->num.frames != 0){
		for (int k=0; k<pDoc->Frames.GetSize(); k++){
			min[0]=pDoc->Frames[k]->fv[0].v[0];
			min[1]=pDoc->Frames[k]->fv[0].v[1];
			min[2]=pDoc->Frames[k]->fv[0].v[2];
			max[0]=min[0];
			max[1]=min[1];
			max[2]=min[2];
			// get bounds of cur frame
			for (int i=0; i<pDoc->num.vertices; i++){
				if(pDoc->Frames[k]->fv[i].v[0]<min[0]) min[0]=pDoc->Frames[k]->fv[i].v[0];
				else if(pDoc->Frames[k]->fv[i].v[0]>max[0]) max[0]=pDoc->Frames[k]->fv[i].v[0];
				if(pDoc->Frames[k]->fv[i].v[1]<min[1]) min[1]=pDoc->Frames[k]->fv[i].v[1];
				else if(pDoc->Frames[k]->fv[i].v[1]>max[1]) max[1]=pDoc->Frames[k]->fv[i].v[1];
				if(pDoc->Frames[k]->fv[i].v[2]<min[2]) min[2]=pDoc->Frames[k]->fv[i].v[2];
				else if(pDoc->Frames[k]->fv[i].v[2]>max[2]) max[2]=pDoc->Frames[k]->fv[i].v[2];
			}
			pDoc->Frames[k]->fbboxmax.v[0]=max[0];
			pDoc->Frames[k]->fbboxmin.v[0]=min[0];
			pDoc->Frames[k]->fbboxmax.v[1]=max[1];
			pDoc->Frames[k]->fbboxmin.v[1]=min[1];
			pDoc->Frames[k]->fbboxmax.v[2]=max[2];
			pDoc->Frames[k]->fbboxmin.v[2]=min[2];
		}
		// find total bounds
		min2[0]=pDoc->Frames[0]->fbboxmin.v[0];
		min2[1]=pDoc->Frames[0]->fbboxmin.v[1];
		min2[2]=pDoc->Frames[0]->fbboxmin.v[2];
		max2[0]=pDoc->Frames[0]->fbboxmax.v[0];
		max2[1]=pDoc->Frames[0]->fbboxmax.v[1];
		max2[2]=pDoc->Frames[0]->fbboxmax.v[2];
		for(int i=0; i<pDoc->Frames.GetSize(); i++)
		{
			for(int j=0; j<3; j++)
			{
				if (pDoc->Frames[i]->fbboxmin.v[j]<min2[j]) min2[j]=pDoc->Frames[i]->fbboxmin.v[j];
				if (pDoc->Frames[i]->fbboxmax.v[j]>max2[j]) max2[j]=pDoc->Frames[i]->fbboxmax.v[j];
			}
		}
		pDoc->boxmax[0]=max2[0];
		pDoc->boxmin[0]=min2[0];
		pDoc->boxmax[1]=max2[1];
		pDoc->boxmin[1]=min2[1];
		pDoc->boxmax[2]=max2[2];
		pDoc->boxmin[2]=min2[2];
	}
	*/
}

////// add & del functs
void DelTri(int triindex)
{
//	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

//	pDoc->Tris.RemoveAt(triindex);
}

void RemoveFrameVert(CMedDLeFrame *f, int vindex);

void DelVert(int vertindex)
{
/*	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

	// delete tri first
	int i,j,k;
	for(i=0; i<pDoc->Tris.GetSize(); i++)
	{
		// if vert in tri, remove it.
		for(j=0; j<3; j++)
		{
			if(vertindex==pDoc->Tris[i].vindex[j])
			{
				DelTri(i);
				i--;
				break;
			}
		}
	}
	// fix all frames
	// first map frame
	RemoveFrameVert(pDoc->MapGen,vertindex);
	// then base
	RemoveFrameVert(pDoc->Base,vertindex);
	// then rest of frames
	for(i=0; i<pDoc->Frames.GetSize(); i++)
		RemoveFrameVert(pDoc->Frames[i], vertindex);
	// fix groups?
	// delete vert
	pDoc->Verts.RemoveAt(vertindex);

  */ 
}

void RemoveFrameVert(CMedDLeFrame *f, int vindex)
{
/*	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

	int i;
	for (i=vindex; i< pDoc->Verts.GetSize()-1; i++)
	{
		f->fv[i].v[0]=f->fv[i+1].v[0];
		f->fv[i].v[1]=f->fv[i+1].v[1];
		f->fv[i].v[2]=f->fv[i+1].v[2];
		f->fv[i].vnormal=f->fv[i+1].vnormal;
	}
*/
}
BOOL AddVert(float x[3])
{
/*	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

	if(pDoc->Verts.GetSize()>=VERT_LIMIT) AfxMessageBox("You hit the vertex limit"); return 0;
	
		VertData vd;
		vd.flags=0;				// Flags
		vd.object=0;
		vd.group=0;		// Object & Group ID#s
		vd.skel=0;				// Skeleton Segment ID#
		vd.dummy=0;				// Dummy Value
		vd.Mflags=0;			// MDL Based Flags Including ONSEEM
		vd.x=10;
		vd.y=10;				// Mapping Coords (If O_HAS_MAP is Set)
		pDoc->Verts.Add(vd);

	int j=pDoc->Verts.GetSize()-1;
	pDoc->Base->fv[j].v[0]=x[0];
	pDoc->Base->fv[j].v[1]=x[1];
	pDoc->Base->fv[j].v[2]=x[2];
	pDoc->Base->fv[j].vnormal=0;
	pDoc->MapGen->fv[j].v[0]=x[0];
	pDoc->MapGen->fv[j].v[1]=x[1];
	pDoc->MapGen->fv[j].v[2]=x[2];
	pDoc->MapGen->fv[j].vnormal=0;
	for (int i=0; i < pDoc->Frames.GetSize(); i++)
	{
		pDoc->Frames[i]->fv[j].v[0]=x[0];
		pDoc->Frames[i]->fv[j].v[1]=x[1];
		pDoc->Frames[i]->fv[j].v[2]=x[2];
		pDoc->Frames[i]->fv[j].vnormal=0;
	}
	*/
	return 1;

}

BOOL AddVert(float x[3], VertData *VD)
{
/*	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;
	if(pDoc->Verts.GetSize()>=VERT_LIMIT) AfxMessageBox("You hit the vertex limit"); return 0;
	
	if(VD==NULL)
	{
		VertData vd;
		vd.flags=0;				// Flags
		vd.object=0;
		vd.group=0;		// Object & Group ID#s
		vd.skel=0;				// Skeleton Segment ID#
		vd.dummy=0;				// Dummy Value
		vd.Mflags=0;			// MDL Based Flags Including ONSEEM
		vd.x=10;
		vd.y=10;				// Mapping Coords (If O_HAS_MAP is Set)
		pDoc->Verts.Add(vd);
	}
	else
		pDoc->Verts.Add(*VD);

	int j=pDoc->Verts.GetSize()-1;
	pDoc->Base->fv[j].v[0]=x[0];
	pDoc->Base->fv[j].v[1]=x[1];
	pDoc->Base->fv[j].v[2]=x[2];
	pDoc->Base->fv[j].vnormal=0;
	pDoc->MapGen->fv[j].v[0]=x[0];
	pDoc->MapGen->fv[j].v[1]=x[1];
	pDoc->MapGen->fv[j].v[2]=x[2];
	pDoc->MapGen->fv[j].vnormal=0;
	for (int i=0; i < pDoc->Frames.GetSize(); i++)
	{
		pDoc->Frames[i]->fv[j].v[0]=x[0];
		pDoc->Frames[i]->fv[j].v[1]=x[1];
		pDoc->Frames[i]->fv[j].v[2]=x[2];
		pDoc->Frames[i]->fv[j].vnormal=0;
	}
	*/
	return 1;

	
}

void AddTri(int vindex[3] )
{
	/*
	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;
	Triangle T;
	T.flags=0;
	T.Vflags=0;
	T.color[0]=0;
	T.color[1]=0;
	T.color[2]=0;
	T.vindex[0]=vindex[0];
	T.vindex[1]=vindex[1];
	T.vindex[2]=vindex[2];
	pDoc->Tris.Add(T);
	*/
}

void AddTri( float v[9] )
{
//	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

//	int vi[3];

//	AddTri(vi);
	
}

void AddVertToBone(float x[3], int bone)
{
//	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;
	
}
